POJ1015 DP

Jury Compromise

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 28927   Accepted: 7676   Special Judge

Description

In Frobnia, a far-away country, the verdicts in court trials are determined by a jury consisting of members of the general public. Every time a trial is set to begin, a jury has to be selected, which is done as follows. First, several people are drawn randomly from the public. For each person in this pool, defence and prosecution assign a grade from 0 to 20 indicating their preference for this person. 0 means total dislike, 20 on the other hand means that this person is considered ideally suited for the jury. 
Based on the grades of the two parties, the judge selects the jury. In order to ensure a fair trial, the tendencies of the jury to favour either defence or prosecution should be as balanced as possible. The jury therefore has to be chosen in a way that is satisfactory to both parties. 
We will now make this more precise: given a pool of n potential jurors and two values di (the defence‘s value) and pi (the prosecution‘s value) for each potential juror i, you are to select a jury of m persons. If J is a subset of {1,..., n} with m elements, then D(J ) = sum(dk) k belong to J 
and P(J) = sum(pk) k belong to J are the total values of this jury for defence and prosecution. 
For an optimal jury J , the value |D(J) - P(J)| must be minimal. If there are several jurys with minimal |D(J) - P(J)|, one which maximizes D(J) + P(J) should be selected since the jury should be as ideal as possible for both parties. 
You are to write a program that implements this jury selection process and chooses an optimal jury given a set of candidates.

Input

The input file contains several jury selection rounds. Each round starts with a line containing two integers n and m. n is the number of candidates and m the number of jury members. 
These values will satisfy 1<=n<=200, 1<=m<=20 and of course m<=n. The following n lines contain the two integers pi and di for i = 1,...,n. A blank line separates each round from the next. 
The file ends with a round that has n = m = 0.

Output

For each round output a line containing the number of the jury selection round (‘Jury #1‘, ‘Jury #2‘, etc.). 
On the next line print the values D(J ) and P (J ) of your jury as shown below and on another line print the numbers of the m chosen candidates in ascending order. Output a blank before each individual candidate number. 
Output an empty line after each test case.

Sample Input

4 2
1 2
2 3
4 1
6 2
0 0 

Sample Output

Jury #1
Best jury has value 6 for prosecution and value 4 for defence:
 2 3 

Hint

If your solution is based on an inefficient algorithm, it may not execute in the allotted time.

Source

Southwestern European Regional Contest 1996

题意:

n个人,每人有两个属性,支持度d和反对度p,从n个人中按照要求选出m个人。要求:m个人的p和与d和的差最小的情况下p+d的和最大,输出d的和,p的和他们分别是谁。

代码:

/*
为叙述问题方便,现将任一选择方案中,辩方总分和控方总分之差简称为“辩控差”,
辩方总分和控方总分之和称为“辩控和”。第i 个候选人的辩方总分和控方总分之差
记为V(i),辩方总分和控方总分之和记为S(i)。现用dp(j, k)表示,取j 个候选人,
使其辩控差为k 的所有方案中,辩控和最大的那个方案(该方案称为“方案dp(j, k)”)
的辩控和。并且,我们还规定,如果没法选j 个人,使其辩控差为k,那么dp(j, k)的
值就为-1,也称方案dp(j, k)不可行。本题是要求选出m 个人,那么,如果对k 的
所有可能的取值,求出了所有的dp(m, k) (-20×m≤ k ≤ 20×m),那么陪审团方案自然
就很容易找到了。
    问题的关键是建立递推关系。需要从哪些已知条件出发,才能求出dp(j, k)呢?
显然,方案dp(j, k)是由某个可行的方案dp(j-1, x)( -20×m ≤ x ≤ 20×m)演化而来的。
可行方案dp(j-1, x)能演化成方案dp(j, k)的必要条件是:存在某个候选人i,i
在方案dp(j-1, x)中没有被选上,且x+V(i) = k。在所有满足该必要条件的dp(j-1, x)中
,选出 dp(j-1, x) + S(i) 的值最大的那个,那么方案dp(j-1, x)再加上候选人i,就
演变成了方案 dp(j, k)。这中间需要将一个方案都选了哪些人都记录下来。不妨将方案
dp(j, k)中最后选的那个候选人的编号,记在二维数组的元素path[j][k]中。那么方案
dp(j, k)的倒数第二个人选的编号,就是path[j-1][k-V[path[j][k]]]。假定最后算出
了解方案的辩控差是k,那么从path[m][k]出发,就能顺藤摸瓜一步步回溯求出所有被选中的候选人。
初始条件,只能确定dp(0, 0) = 0,其他均为-1。由此出发,一步步自底向上递推,就
能求出所有的可行方案dp(m, k)( -20×m ≤ k ≤ 20×m)。实际解题的时候,会用一个二维
数组dp 来存放dp(j, k)的值。而且,由于题目中辩控差的值k 可以为负数,而程序中数
租下标不能为负数,所以,在程序中不妨将辩控差的值都加上修正值fix=400,以免下标
为负数导致出错。
为什么fix=400?这是很显然的,m上限为20人,当20人的d均为0,p均为20时,会出现辨
控差为-400。修正后回避下标负数问题,区间整体平移,从[-400,400]映射到[0,800]。
此时初始条件修正为dp(0, fix) = 0,其他均为-1。
DP后,从第m行的dp(m, fix)开始往两边搜索最小|D-P| 即可,第一个不为dp[m][k]!=-1的
位置k就是最小|D-P|的所在。
最后就是求m个人的D和P,由于D+P = dp(m, |D-P| ) ,|D-P|已知。
那么D= (D+P + |D-P| )/2  ,  P=(D+P-|D-P| ) / 2
计算D和P时注意修正值fix
*/
#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
int d[300],p[300],c[300],h[300],f[30][900],path[30][900];
int main()
{
    int n,m,cas=0;
    while(scanf("%d%d",&n,&m)&&(n+m)){
        for(int i=1;i<=n;i++){
            scanf("%d%d",&d[i],&p[i]);
            c[i]=d[i]-p[i];
            h[i]=d[i]+p[i];
        }
        memset(f,-1,sizeof(f));
        memset(path,0,sizeof(path));
        int M=m*20;
        f[0][M]=0;
        for(int i=0;i<m;i++){
            for(int j=0;j<=M*2;j++){
                if(f[i][j]==-1) continue;
                for(int k=1;k<=n;k++){
                    if(f[i][j]+h[k]>f[i+1][j+c[k]]){
                        int t1=i,t2=j;
                        while(t1>0&&path[t1][t2]!=k){
                            t2-=c[path[t1][t2]];
                            t1--;
                        }
                        if(t1==0){
                            f[i+1][j+c[k]]=f[i][j]+h[k];
                            path[i+1][j+c[k]]=k;
                        }
                    }
                }
            }
        }
        int i;
        for(i=0;;i++){
            if(f[m][M+i]!=-1) break;
            if(f[m][M-i]!=-1) break;
        }
        int ans1,ans2,t1=m,t2;
        if(f[m][M+i]>f[m][M-i]){
            ans1=(i+f[m][M+i])/2;
            ans2=f[m][M+i]-ans1;
            t2=M+i;
        }
        else{
            ans1=(-i+f[m][M-i])/2;
            ans2=f[m][M-i]-ans1;
            t2=M-i;
        }
        printf("Jury #%d\n",++cas);
        printf("Best jury has value %d for prosecution and value %d for defence:\n",ans1,ans2);
        int tmp[30],cnt=0;
        while(t1){
            tmp[cnt++]=path[t1][t2];
            t2-=c[path[t1][t2]];
            t1--;
        }
        sort(tmp,tmp+cnt);
        for(int j=0;j<cnt;j++) printf(" %d",tmp[j]);
        printf("\n\n");
    }
    return 0;
}
时间: 2024-10-17 17:57:45

POJ1015 DP的相关文章

poj1015 正解--二维DP(完全背包)

题目链接:http://poj.org/problem?id=1015 错误解法: 网上很多解法是错误的,用dp[i][j]表示选择i个人差值为j的最优解,用path[i][j]存储路径,循环次序为"选的第几个人->选哪个人->差值之和"或者"选的第几个人->差值之和->选哪个人",为了避免选择重复的人需要判断.错误的原因是存储路径的方式使得会覆盖一些情况,比如1 3 5和2 4 6均满足dp[3][k]最优时,若采用2 4 6作为dp[3]

DP总结 ——QPH

常见优化 单调队列 形式 dp[i]=min{f(k)} dp[i]=max{f(k)} 要求 f(k)是关于k的函数 k的范围和i有关 转移方法 维护一个单调递增(减)的队列,可以在两头弹出元素,一头压入元素. 队列中维护的是两个值.一个是位置,这和k的范围有关系,另外一个是f(k)的值,这个用来维护单调性,当然如果f(k)的值可以利用dp值在O(1)的时间内计算出来的话队列中可以只维护一个表示位置的变量. 枚举到一个i的时候,首先判断队首元素的位置是否已经不满足k的范围了,如果不满足就将队首

POJ1015 动态规划

POJ1015 问题重述: 在n个候选者中选取m个人进入陪审团.每个候选者获得两项评分:D[j],P[j].求解最佳评审团,使得在每个成员的两项评分和之差 最小的情况下,使得两项评分和之和 最大. 分析: 欲采用动态规划求解,必须先找到最优子结构.假如考虑评分差的绝对值,它的子问题并不一定是最优解.若考虑一定评分差下的评分和最大值,则拥有最优子结构. 用dp[i][j]表示在第i个评委评分后,评分差是j的最大评分和,得到递归公式: dp[i][j] = max{ dp[ i - 1 ][ j -

「kuangbin带你飞」专题十二 基础DP

layout: post title: 「kuangbin带你飞」专题十二 基础DP author: "luowentaoaa" catalog: true tags: mathjax: true - kuangbin - 动态规划 传送门 A.HDU1024 Max Sum Plus Plus 题意 给你N个数,然后你分成M个不重叠部分,并且这M个不重叠部分的和最大. 思路 动态规划最大m字段和,dp数组,dp[i][j]表示以a[j]结尾的,i个字段的最大和 两种情况:1.第a[j

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

POJ - 3186 Treats for the Cows (区间DP)

题目链接:http://poj.org/problem?id=3186 题意:给定一组序列,取n次,每次可以取序列最前面的数或最后面的数,第n次出来就乘n,然后求和的最大值. 题解:用dp[i][j]表示i~j区间和的最大值,然后根据这个状态可以从删前和删后转移过来,推出状态转移方程: dp[i][j]=max(dp[i+1][j]+value[i]*k,dp[i][j-1]+value[j]*k) 1 #include <iostream> 2 #include <algorithm&

51Nod 1009 数字1的个数 | 数位DP

题意: 小于等于n的所有数中1的出现次数 分析: 数位DP 预处理dp[i][j]存 从1~以j开头的i位数中有几个1,那么转移方程为: if(j == 1) dp[i][j] = dp[i-1][9]*2+pow(10,i-1);else dp[i][j] = dp[i-1][9]+dp[i][j-1]; 然后注意下对于每个询问统计的时候如果当前位为1需要额外加上他后面所有位数的个数,就是n%pow(10,i-1); 这样总复杂度log(n)*10 #include <bits/stdc++.

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是